package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import java.sql.*;
import java.io.*;
public class FuriousPOOL_SYS {
  public String TypeCNX="", Host="", Port="", Database="", User="", Password="", Option="", Separator="", Premier="";
  int MaxPOOL=0, MaxWaitForNew=0;
  boolean CNXCharger = false;
  public FuriousCONNECTION_SYS[] Pool = null;
public FuriousPOOL_SYS (String ID) throws Exception {
  if (FurPRGM_1.ExistConnection(ID)) {
    try {
      this.TypeCNX=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "Type");
      this.Host=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "Host");
      this.Port=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "Port");
      this.Database=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "BaseName");
      this.User=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "User");
      this.Option=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "Option");
      this.Separator=Fur_File.getINIinfos("webapps/DBSConnector/JDBCDrivers/"+TypeCNX, "DRIVER", "Separator");
      this.Premier=Fur_File.getINIinfos("webapps/DBSConnector/JDBCDrivers/"+TypeCNX, "DRIVER", "First");
      this.Password=Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "Password");
      this.MaxPOOL=Integer.parseInt(Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "MaxPOOL"));
      this.MaxWaitForNew=Integer.parseInt(Fur_File.getINIinfos("webapps/DBSConnector/Connections/"+ID+"/.Database", "CNX", "MaxWaitForNew"));
      this.Pool= new FuriousCONNECTION_SYS[MaxPOOL];
      for(int i=0;i<MaxPOOL;i++)
        this.Pool[i]=new FuriousCONNECTION_SYS();
    } catch (Exception e) {Fur_File.Trace("ERROR: FuriousPOOL_SYS.FuriousPOOL_SYS: "+e.getMessage());
      throw new FuriousPOOLException_SYS("Unknown error when loading "+ID+" connection ... contact your Administrator: "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Civilite")+" "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Nom")+" "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Prenom")+" ("+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "fix")+", "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "gsm")+", "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "mail")+").");
    };
  } else {
    throw new FuriousPOOLException_SYS("The connection '"+ID+"' don't exist ... contact your Administrator: "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Civilite")+" "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Nom")+" "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Prenom")+" ("+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "fix")+", "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "gsm")+", "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "mail")+").");
  }
}
public synchronized FuriousCONNECTION_SYS GetFuriousConnection() throws Exception {
  boolean PasTrouve=true;
  FuriousCONNECTION_SYS CNXFuriousDisponible = null;
  long TimeDebut = System.currentTimeMillis();
  int iConnection=0, iNbConnection=this.Pool.length;
  if (this.MaxWaitForNew!=-1) {
    while (PasTrouve && (System.currentTimeMillis()-TimeDebut)<=(this.MaxWaitForNew*1000)) {
      for(iConnection=0;iConnection<iNbConnection;iConnection++) {
        if (this.Pool[iConnection].Libre) {
          if (this.Pool[iConnection].CNX==null) {
            this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.Password, this.Option, this.Separator, this.Premier);
            CNXFuriousDisponible = this.Pool[iConnection];
            CNXFuriousDisponible.idpool=iConnection;
            this.Pool[iConnection].Libre=false;
            this.Pool[iConnection].Valide=true;
            PasTrouve=false;
            break;
          } else {
            if (this.Pool[iConnection].isValide()) {
              CNXFuriousDisponible = this.Pool[iConnection];
              CNXFuriousDisponible.idpool=iConnection;
              this.Pool[iConnection].Libre=false;
              this.Pool[iConnection].Valide=true;
              PasTrouve=false;
              break;
            } else {
              this.Pool[iConnection].Valide=false;
              this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.Password, this.Option, this.Separator, this.Premier);
              CNXFuriousDisponible = this.Pool[iConnection];
              CNXFuriousDisponible.idpool=iConnection;
              this.Pool[iConnection].Libre=false;
              this.Pool[iConnection].Valide=true;
              PasTrouve=false;
              break;
            }
          }
        }
      }
      if (PasTrouve) Thread.currentThread().sleep(500);
    }
    if (PasTrouve) throw new FuriousPOOLException_SYS("Time out for receive new connection ... contact your Administrator: "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Civilite")+" "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Nom")+" "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "Prenom")+" ("+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "fix")+", "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "gsm")+", "+Fur_File.getINIinfos("webapps/DBSConnector/USERS/root/.jimmitry", "User", "mail")+").");
  } else {
    while (PasTrouve) {
      for(iConnection=0;iConnection<iNbConnection;iConnection++) {
        if (this.Pool[iConnection].Libre) {
          if (this.Pool[iConnection].CNX==null) {
            this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.Password, this.Option, this.Separator, this.Premier);
            CNXFuriousDisponible = this.Pool[iConnection];
            CNXFuriousDisponible.idpool=iConnection;
            this.Pool[iConnection].Libre=false;
            this.Pool[iConnection].Valide=true;
            PasTrouve=false;
            break;
          } else {
            if (this.Pool[iConnection].isValide()) {
              CNXFuriousDisponible = this.Pool[iConnection];
              CNXFuriousDisponible.idpool=iConnection;
              this.Pool[iConnection].Libre=false;
              this.Pool[iConnection].Valide=true;
              PasTrouve=false;
              break;
            } else {
              this.Pool[iConnection].Valide=false;
              this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.Password, this.Option, this.Separator, this.Premier);
              CNXFuriousDisponible = this.Pool[iConnection];
              CNXFuriousDisponible.idpool=iConnection;
              this.Pool[iConnection].Libre=false;
              this.Pool[iConnection].Valide=true;
              PasTrouve=false;
              break;
            }
          }
        }
      }
      if (PasTrouve) Thread.currentThread().sleep(500);
    }
  }
  CNXFuriousDisponible.nbCall++;
  return CNXFuriousDisponible;
}
}
