package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import re.jimmitry.apps974.fursys.*;
import re.jimmitry.apps974.wsfurious.*;
import re.jimmitry.apps974.wsfurious.xsd.*;
import java.net.*;
import java.sql.*;
import java.io.*;
import java.util.Enumeration;
import org.xml.sax.*;
import org.h2.tools.Server;
import java.util.HashMap;
import java.util.Vector;
import java.util.GregorianCalendar;
import java.util.regex.Pattern;
public class SQL_DBSConnector {
public static FurSYS_DATA ABS(FurSYS_DATA DATA1) {
  return SQL_MATH.ABS(DATA1);
}
public static FurSYS_DATA ADD(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_MATH.ADD(DATA1, DATA2);
}
public static FurSYS_DATA AND(FurSYS_DATA BOOL1, FurSYS_DATA BOOL2) {
  return SQL_BOOL.AND(BOOL1, BOOL2);
}
public static FurSYS_DATA AVG(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.AVG(olddata, newdata);
}
public static FurSYS_DATA BACKUP(FurSYS_DATA DATA1) {
  return SQL_SYSTEM.BACKUP(DATA1);
}
public static FurSYS_DATA CEIL(FurSYS_DATA DATA1) {
  return SQL_MATH.CEIL(DATA1);
}
public static FurSYS_DATA CERTGRANTLIST(FurSYS_DATA USER) {
  return new FurSYS_DATA(false, FurPRGM_6.getListGrantCertificat(USER.DATA));
}
public static FurSYS_DATA CHANGECRON(FurSYS_DATA SQL, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.CHANGECRON(SQL, SERVER);
}
public static FurSYS_DATA CHR(FurSYS_DATA DATA1) {
  return SQL_STRING.CHR(DATA1);
}
//In internal ...
public static FurSYS_DATA CONCAT(FurSYS_DATA str1, FurSYS_DATA str2) {
  return SQL_STRING.CONCAT(str1, str2);
}
public static FurSYS_DATA COUNT(FurSYS_DATA olddata) {
  return SQL_AGREG.COUNT(olddata);
}
public static FurSYS_DATA DATA2HTML(FurSYS_DATA DATA1) {
  return SQL_XML.DATA2HTML(DATA1);
}
public static FurSYS_DATA DATEFR(FurSYS_DATA DATA1) {
  return SQL_DATE.DATEFR(DATA1);
}
// In internal ...
// In internal ...
public static FurSYS_DATA DELETEBACKUP(FurSYS_DATA DATA1) {
  return SQL_SYSTEM.DELETEBACKUP(DATA1);
}
//In internal ...
public static FurSYS_DATA DEPLOY(FurSYS_DATA TYPEOBJ, FurSYS_DATA OBJDEP, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOY(TYPEOBJ, OBJDEP, SERVER);
}
public static FurSYS_DATA DEPLOYCLASS(FurSYS_DATA CLASS, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOYCLASS(CLASS, SERVER);
}
public static FurSYS_DATA DEPLOYCONNECTION(FurSYS_DATA CONNECTION, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOYCONNECTION(CONNECTION, SERVER);
}
public static FurSYS_DATA DEPLOYSITE(FurSYS_DATA SITE, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOYSITE(SITE, SERVER);
}
public static FurSYS_DATA DEPLOYSQL(FurSYS_DATA SQL, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOYSQL(SQL, SERVER);
}
public static FurSYS_DATA DEPLOYUSER(FurSYS_DATA USER, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOYUSER(USER, SERVER);
}
public static FurSYS_DATA DEPLOYWEBSITE(FurSYS_DATA WEBSITE, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.DEPLOYWEBSITE(WEBSITE, SERVER);
}
public static FurSYS_DATA DIV(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_MATH.DIV(DATA1, DATA2);
}
public static FurSYS_DATA ENDSWITH(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.ENDSWITH(DATA1, DATA2);
}
public static FurSYS_DATA EQUAL(FurSYS_DATA str1, FurSYS_DATA str2) {
  return SQL_BOOL.EQUAL(str1, str2);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1) {
  return SQL_PRGM.EXE(str1);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2) {
  return SQL_PRGM.EXE(str1, str2);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3) {
  return SQL_PRGM.EXE(str1, str2, str3);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4) {
  return SQL_PRGM.EXE(str1, str2, str3, str4);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4, FurSYS_DATA str5) {
  return SQL_PRGM.EXE(str1, str2, str3, str4, str5);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4, FurSYS_DATA str5, FurSYS_DATA str6) {
  return SQL_PRGM.EXE(str1, str2, str3, str4, str5, str6);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4, FurSYS_DATA str5, FurSYS_DATA str6, FurSYS_DATA str7) {
  return SQL_PRGM.EXE(str1, str2, str3, str4, str5, str6, str7);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4, FurSYS_DATA str5, FurSYS_DATA str6, FurSYS_DATA str7, FurSYS_DATA str8) {
  return SQL_PRGM.EXE(str1, str2, str3, str4, str5, str6, str7, str8);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4, FurSYS_DATA str5, FurSYS_DATA str6, FurSYS_DATA str7, FurSYS_DATA str8, FurSYS_DATA str9) {
  return SQL_PRGM.EXE(str1, str2, str3, str4, str5, str6, str7, str8, str9);
}
public static FurSYS_DATA EXE(FurSYS_DATA str1, FurSYS_DATA str2, FurSYS_DATA str3, FurSYS_DATA str4, FurSYS_DATA str5, FurSYS_DATA str6, FurSYS_DATA str7, FurSYS_DATA str8, FurSYS_DATA str9, FurSYS_DATA str10) {
  return SQL_PRGM.EXE(str1, str2, str3, str4, str5, str6, str7, str8, str9, str10);
}
public static FurSYS_DATA EXECMD(FurSYS_DATA CMD) {
  return SQL_SYSTEM.EXECMD(CMD);
}
//In internal ...
// In internal ...
public static FurSYS_DATA EXISTDATA(FurSYS_DATA VARDATA, FurSYS_DATA COLUMNSEARCH, FurSYS_DATA DATASEARCH) {
  return SQL_XML.EXISTDATA(VARDATA, COLUMNSEARCH, DATASEARCH);
}
//In internal ...
public static FurSYS_DATA FIRST(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.FIRST(olddata, newdata);
}
public static FurSYS_DATA FLOOR(FurSYS_DATA DATA1) {
  return SQL_MATH.FLOOR(DATA1);
}
// In internal ...
public static FurSYS_DATA GC(FurSYS_DATA DATA1) {
  return SQL_SYSTEM.GC(DATA1);
}
// In internal ...
public static FurSYS_DATA GETACTIVITY(FurSYS_DATA Nothing) {
  return SQL_SERVER.GETACTIVITY(Nothing);
}
public static FurSYS_DATA GETATOME(FurSYS_DATA DATA1, FurSYS_DATA DATA2, FurSYS_DATA DATA3) {
  return SQL_ATOME.GETATOME(DATA1, DATA2, DATA3);
}
public static FurSYS_DATA GETATOMESIZE(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_ATOME.GETATOMESIZE(DATA1, DATA2);
}
public static FurSYS_DATA GETCLASS(FurSYS_DATA Nothing) {
  return SQL_SERVER.GETCLASS(Nothing);
}
public static FurSYS_DATA GETCONNECTION(FurSYS_DATA Nothing) {
  return SQL_SERVER.GETCONNECTION(Nothing);
}
public static FurSYS_DATA GETFIRSTATOME(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_ATOME.GETFIRSTATOME(DATA1, DATA2);
}
public static FurSYS_DATA GETLASTATOME(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_ATOME.GETLASTATOME(DATA1, DATA2);
}
//In internal ...
//In internal ...
public static FurSYS_DATA GETSERVER(FurSYS_DATA PbAdresse, FurSYS_DATA IndexServer, FurSYS_DATA PcHTTP) {
  return SQL_SERVER.GETSERVER(PbAdresse, IndexServer, PcHTTP);
}
public static FurSYS_DATA GETSITE(FurSYS_DATA Nothing) {
  return SQL_SERVER.GETSITE(Nothing);
}
public static FurSYS_DATA GETUSER(FurSYS_DATA Nothing) {
  return SQL_SERVER.GETUSER(Nothing);
}
//In internal ...
// In internal ...
public static FurSYS_DATA GETWEBSITE(FurSYS_DATA Nothing) {
  return SQL_SERVER.GETWEBSITE(Nothing);
}
//in internal ...
public static FurSYS_DATA GREATER(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.GREATER(DATA1, DATA2);
}
public static FurSYS_DATA GREATERE(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.GREATERE(DATA1, DATA2);
}
public static FurSYS_DATA HEXREAD(FurSYS_DATA DATA1) {
  return SQL_FILE.HEXREAD(DATA1);
}
public static FurSYS_DATA HEXWRITE(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_FILE.HEXWRITE(DATA1, DATA2);
}
public static FurSYS_DATA HTML2DATA(FurSYS_DATA DATA1) {
  return SQL_XML.HTML2DATA(DATA1);
}
public static FurSYS_DATA IF(FurSYS_DATA cond, FurSYS_DATA ifcondTrue, FurSYS_DATA ifcondFalse) {
  return SQL_PRGM.IF(cond, ifcondTrue, ifcondFalse);
}
public static FurSYS_DATA INSTR(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_STRING.INSTR(DATA1, DATA2);
}
public static FurSYS_DATA INSTR(FurSYS_DATA DATA1, FurSYS_DATA DATA2, FurSYS_DATA DATA3) {
  return SQL_STRING.INSTR(DATA1, DATA2, DATA3);
}
public static FurSYS_DATA ISBOOL(FurSYS_DATA data, FurSYS_DATA bool1, FurSYS_DATA bool2) {
  return SQL_BOOL.ISBOOL(data, bool1, bool2);
}
public static FurSYS_DATA ISCHAR(FurSYS_DATA DATA, FurSYS_DATA SIZE) {
  return SQL_BOOL.ISCHAR(DATA, SIZE);
}
public static FurSYS_DATA ISDATE(FurSYS_DATA DATA) { //Exemple: '1980-06-18'
  return SQL_BOOL.ISDATE(DATA);
}
public static FurSYS_DATA ISDECIMAL(FurSYS_DATA ch, FurSYS_DATA E, FurSYS_DATA F)
{
  return SQL_BOOL.ISDECIMAL(ch, E, F);
}
public static FurSYS_DATA ISENUM(FurSYS_DATA data, FurSYS_DATA ENUM, FurSYS_DATA SEPARATOR)
{
  return SQL_BOOL.ISENUM(data, ENUM, SEPARATOR);
}
public static FurSYS_DATA ISHOUR(FurSYS_DATA DATA) { // Exemple: 12:35:56
  return SQL_BOOL.ISHOUR(DATA);
}
public static FurSYS_DATA ISINTEGER(FurSYS_DATA data, FurSYS_DATA size)
{
  return SQL_BOOL.ISINTEGER(data, size);
}
public static FurSYS_DATA ISNULL(FurSYS_DATA str) {
  return SQL_BOOL.ISNULL(str);
}
public static FurSYS_DATA ISNUMBER(FurSYS_DATA DATA) {
  return SQL_BOOL.ISNUMBER(DATA);
}
public static FurSYS_DATA ISTIMESTAMP(FurSYS_DATA DATA) {// Exemple: 2009-06-18 12:00:00
  return SQL_BOOL.ISTIMESTAMP(DATA);
}
public static FurSYS_DATA ISVARCHAR(FurSYS_DATA DATA, FurSYS_DATA SIZE) {
  return SQL_BOOL.ISVARCHAR(DATA, SIZE);
}
public static FurSYS_DATA ITRIM(FurSYS_DATA DATA1) {
  return SQL_STRING.ITRIM(DATA1);
}
// In internal ...
public static FurSYS_DATA LAST(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.LAST(olddata, newdata);
}
// in internal ...
public static FurSYS_DATA LENGTH(FurSYS_DATA str) {
  return SQL_STRING.LENGTH(str);
}
public static FurSYS_DATA LESS(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.LESS(DATA1, DATA2);
}
public static FurSYS_DATA LESSE(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.LESSE(DATA1, DATA2);
}
public static FurSYS_DATA LIKE(FurSYS_DATA str1, FurSYS_DATA str2) {
  return SQL_BOOL.LIKE(str1, str2);
}
public static FurSYS_DATA LIKESPECIAL(FurSYS_DATA DATA) {
  return SQL_STRING.LIKESPECIAL(DATA);
}
public static FurSYS_DATA LIKESPECIAL2(FurSYS_DATA DATA) {
  return SQL_STRING.LIKESPECIAL2(DATA);
}
// in internal ...
public static FurSYS_DATA LOCALIP(FurSYS_DATA nothing) {
  return SQL_NETWORK.LOCALIP(nothing);
}
public static FurSYS_DATA LOCALMAC(FurSYS_DATA nothing) {
  return SQL_NETWORK.LOCALMAC(nothing);
}

public static FurSYS_DATA LOWER(FurSYS_DATA DATA1) {
  return SQL_STRING.LOWER(DATA1);
}
public static FurSYS_DATA LPAD(FurSYS_DATA DATA1, FurSYS_DATA DATA2, FurSYS_DATA DATA3) {
  return SQL_STRING.LPAD(DATA1, DATA2, DATA3);
}
public static FurSYS_DATA LRTRIM(FurSYS_DATA DATA1) {
  return SQL_STRING.LRTRIM(DATA1);
}
public static FurSYS_DATA LTRIM(FurSYS_DATA DATA1) {
  return SQL_STRING.LTRIM(DATA1);
}
//In internal ...
//In internal ...
public static FurSYS_DATA MAX(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.MAX(olddata, newdata);
}
public static FurSYS_DATA MAXSTR(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.MAXSTR(olddata, newdata);
}
public static FurSYS_DATA MIN(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.MIN(olddata, newdata);
}
public static FurSYS_DATA MINSTR(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.MINSTR(olddata, newdata);
}
public static FurSYS_DATA MUL(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_MATH.MUL(DATA1, DATA2);
}
public static FurSYS_DATA NOT(FurSYS_DATA BOOL) {
  return SQL_BOOL.NOT(BOOL);
}
public static FurSYS_DATA NUMEQUAL(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.NUMEQUAL(DATA1, DATA2);
}
public static FurSYS_DATA OR(FurSYS_DATA BOOL1, FurSYS_DATA BOOL2) {
  return SQL_BOOL.OR(BOOL1, BOOL2);
}
public static FurSYS_DATA PING(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_NETWORK.PING(DATA1, DATA2);
}
// In internal ...
public static FurSYS_DATA PINGPORT(FurSYS_DATA Host, FurSYS_DATA Port) {
  return SQL_NETWORK.PINGPORT(Host, Port);
}
public static FurSYS_DATA PINGURL(FurSYS_DATA url) {
  return SQL_INTERNET.PINGURL(url);
}
public static FurSYS_DATA POWER(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_MATH.POWER(DATA1, DATA2);
}
//In internal ...
public static FurSYS_DATA REPLACE(FurSYS_DATA DATA1, FurSYS_DATA DATA2, FurSYS_DATA DATA3) {
  return SQL_STRING.REPLACE(DATA1, DATA2, DATA3);
}
public static FurSYS_DATA ROUND(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_MATH.ROUND(DATA1, DATA2);
}
public static FurSYS_DATA RPAD(FurSYS_DATA DATA1, FurSYS_DATA DATA2, FurSYS_DATA DATA3) {
  return SQL_STRING.RPAD(DATA1, DATA2, DATA3);
}
public static FurSYS_DATA RTRIM(FurSYS_DATA DATA1) {
  return SQL_STRING.RTRIM(DATA1);
}
// in internal ...
//In internal ...
// In internal ...
public static FurSYS_DATA SIGN(FurSYS_DATA DATA1) {
  return SQL_MATH.SIGN(DATA1);
}
public static FurSYS_DATA SQRT(FurSYS_DATA DATA1) {
  return SQL_MATH.SQRT(DATA1);
}
//in internal ...
public static FurSYS_DATA STARTCRON(FurSYS_DATA SQL, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.STARTCRON(SQL, SERVER);
}
public static FurSYS_DATA STARTSWITH(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_BOOL.STARTSWITH(DATA1, DATA2);
}
// In internal ...
public static FurSYS_DATA STOPCRON(FurSYS_DATA SQL, FurSYS_DATA SERVER) {
  return SQL_DEPLOY.STOPCRON(SQL, SERVER);
}
public static FurSYS_DATA SUB(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_MATH.SUB(DATA1, DATA2);
}
public static FurSYS_DATA SUBLRCHAR(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_STRING.SUBLRCHAR(DATA1, DATA2);
}
public static FurSYS_DATA SUBSTR(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  return SQL_STRING.SUBSTR(DATA1, DATA2);
}
public static FurSYS_DATA SUBSTR(FurSYS_DATA DATA1, FurSYS_DATA DATA2, FurSYS_DATA DATA3) {
    return SQL_STRING.SUBSTR(DATA1, DATA2, DATA3);
}
public static FurSYS_DATA SUM(FurSYS_DATA olddata, FurSYS_DATA newdata) {
  return SQL_AGREG.SUM(olddata, newdata);
}
// In internal ...
public static FurSYS_DATA SYSDATER(FurSYS_DATA str) {
  return SQL_DATE.SYSDATER(str);
}
//In internal ...
public static FurSYS_DATA SYSTIMESTAMPR(FurSYS_DATA str) {
  return SQL_DATE.SYSTIMESTAMPR(str);
}
public static FurSYS_DATA TRACE(FurSYS_DATA DATA1) {
  return SQL_LOG.TRACE(DATA1);
}
public static FurSYS_DATA TRIM(FurSYS_DATA DATA1) {
  return SQL_STRING.TRIM(DATA1);
}
public static FurSYS_DATA TXT(FurSYS_DATA DATA) {
  return SQL_STRING.TXT(DATA);
}
public static FurSYS_DATA TXT2(FurSYS_DATA DATA) {
  return SQL_STRING.TXT2(DATA);
}
public static FurSYS_DATA UPPER(FurSYS_DATA DATA1) {
  return SQL_STRING.UPPER(DATA1);
}
public static FurSYS_DATA WAIT(FurSYS_DATA DATA1) {
  return SQL_ACTIVITY.WAIT(DATA1);
}
//In internal ...
}
